t / test-lib-functions.shon commit diff.c: add set_sign to emit_line_0 (017ac45)
   1# Library of functions shared by all tests scripts, included by
   2# test-lib.sh.
   3#
   4# Copyright (c) 2005 Junio C Hamano
   5#
   6# This program is free software: you can redistribute it and/or modify
   7# it under the terms of the GNU General Public License as published by
   8# the Free Software Foundation, either version 2 of the License, or
   9# (at your option) any later version.
  10#
  11# This program is distributed in the hope that it will be useful,
  12# but WITHOUT ANY WARRANTY; without even the implied warranty of
  13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  14# GNU General Public License for more details.
  15#
  16# You should have received a copy of the GNU General Public License
  17# along with this program.  If not, see http://www.gnu.org/licenses/ .
  18
  19# The semantics of the editor variables are that of invoking
  20# sh -c "$EDITOR \"$@\"" files ...
  21#
  22# If our trash directory contains shell metacharacters, they will be
  23# interpreted if we just set $EDITOR directly, so do a little dance with
  24# environment variables to work around this.
  25#
  26# In particular, quoting isn't enough, as the path may contain the same quote
  27# that we're using.
  28test_set_editor () {
  29        FAKE_EDITOR="$1"
  30        export FAKE_EDITOR
  31        EDITOR='"$FAKE_EDITOR"'
  32        export EDITOR
  33}
  34
  35test_set_index_version () {
  36    GIT_INDEX_VERSION="$1"
  37    export GIT_INDEX_VERSION
  38}
  39
  40test_decode_color () {
  41        awk '
  42                function name(n) {
  43                        if (n == 0) return "RESET";
  44                        if (n == 1) return "BOLD";
  45                        if (n == 2) return "FAINT";
  46                        if (n == 3) return "ITALIC";
  47                        if (n == 7) return "REVERSE";
  48                        if (n == 30) return "BLACK";
  49                        if (n == 31) return "RED";
  50                        if (n == 32) return "GREEN";
  51                        if (n == 33) return "YELLOW";
  52                        if (n == 34) return "BLUE";
  53                        if (n == 35) return "MAGENTA";
  54                        if (n == 36) return "CYAN";
  55                        if (n == 37) return "WHITE";
  56                        if (n == 40) return "BLACK";
  57                        if (n == 41) return "BRED";
  58                        if (n == 42) return "BGREEN";
  59                        if (n == 43) return "BYELLOW";
  60                        if (n == 44) return "BBLUE";
  61                        if (n == 45) return "BMAGENTA";
  62                        if (n == 46) return "BCYAN";
  63                        if (n == 47) return "BWHITE";
  64                }
  65                {
  66                        while (match($0, /\033\[[0-9;]*m/) != 0) {
  67                                printf "%s<", substr($0, 1, RSTART-1);
  68                                codes = substr($0, RSTART+2, RLENGTH-3);
  69                                if (length(codes) == 0)
  70                                        printf "%s", name(0)
  71                                else {
  72                                        n = split(codes, ary, ";");
  73                                        sep = "";
  74                                        for (i = 1; i <= n; i++) {
  75                                                printf "%s%s", sep, name(ary[i]);
  76                                                sep = ";"
  77                                        }
  78                                }
  79                                printf ">";
  80                                $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
  81                        }
  82                        print
  83                }
  84        '
  85}
  86
  87lf_to_nul () {
  88        perl -pe 'y/\012/\000/'
  89}
  90
  91nul_to_q () {
  92        perl -pe 'y/\000/Q/'
  93}
  94
  95q_to_nul () {
  96        perl -pe 'y/Q/\000/'
  97}
  98
  99q_to_cr () {
 100        tr Q '\015'
 101}
 102
 103q_to_tab () {
 104        tr Q '\011'
 105}
 106
 107qz_to_tab_space () {
 108        tr QZ '\011\040'
 109}
 110
 111append_cr () {
 112        sed -e 's/$/Q/' | tr Q '\015'
 113}
 114
 115remove_cr () {
 116        tr '\015' Q | sed -e 's/Q$//'
 117}
 118
 119# In some bourne shell implementations, the "unset" builtin returns
 120# nonzero status when a variable to be unset was not set in the first
 121# place.
 122#
 123# Use sane_unset when that should not be considered an error.
 124
 125sane_unset () {
 126        unset "$@"
 127        return 0
 128}
 129
 130test_tick () {
 131        if test -z "${test_tick+set}"
 132        then
 133                test_tick=1112911993
 134        else
 135                test_tick=$(($test_tick + 60))
 136        fi
 137        GIT_COMMITTER_DATE="$test_tick -0700"
 138        GIT_AUTHOR_DATE="$test_tick -0700"
 139        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 140}
 141
 142# Stop execution and start a shell. This is useful for debugging tests.
 143#
 144# Be sure to remove all invocations of this command before submitting.
 145
 146test_pause () {
 147        "$SHELL_PATH" <&6 >&5 2>&7
 148}
 149
 150# Wrap git with a debugger. Adding this to a command can make it easier
 151# to understand what is going on in a failing test.
 152#
 153# Examples:
 154#     debug git checkout master
 155#     debug --debugger=nemiver git $ARGS
 156#     debug -d "valgrind --tool=memcheck --track-origins=yes" git $ARGS
 157debug () {
 158        case "$1" in
 159        -d)
 160                GIT_DEBUGGER="$2" &&
 161                shift 2
 162                ;;
 163        --debugger=*)
 164                GIT_DEBUGGER="${1#*=}" &&
 165                shift 1
 166                ;;
 167        *)
 168                GIT_DEBUGGER=1
 169                ;;
 170        esac &&
 171        GIT_DEBUGGER="${GIT_DEBUGGER}" "$@" <&6 >&5 2>&7
 172}
 173
 174# Call test_commit with the arguments
 175# [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
 176#
 177# This will commit a file with the given contents and the given commit
 178# message, and tag the resulting commit with the given tag name.
 179#
 180# <file>, <contents>, and <tag> all default to <message>.
 181#
 182# If the first argument is "-C", the second argument is used as a path for
 183# the git invocations.
 184
 185test_commit () {
 186        notick= &&
 187        signoff= &&
 188        indir= &&
 189        while test $# != 0
 190        do
 191                case "$1" in
 192                --notick)
 193                        notick=yes
 194                        ;;
 195                --signoff)
 196                        signoff="$1"
 197                        ;;
 198                -C)
 199                        indir="$2"
 200                        shift
 201                        ;;
 202                *)
 203                        break
 204                        ;;
 205                esac
 206                shift
 207        done &&
 208        indir=${indir:+"$indir"/} &&
 209        file=${2:-"$1.t"} &&
 210        echo "${3-$1}" > "$indir$file" &&
 211        git ${indir:+ -C "$indir"} add "$file" &&
 212        if test -z "$notick"
 213        then
 214                test_tick
 215        fi &&
 216        git ${indir:+ -C "$indir"} commit $signoff -m "$1" &&
 217        git ${indir:+ -C "$indir"} tag "${4:-$1}"
 218}
 219
 220# Call test_merge with the arguments "<message> <commit>", where <commit>
 221# can be a tag pointing to the commit-to-merge.
 222
 223test_merge () {
 224        test_tick &&
 225        git merge -m "$1" "$2" &&
 226        git tag "$1"
 227}
 228
 229# This function helps systems where core.filemode=false is set.
 230# Use it instead of plain 'chmod +x' to set or unset the executable bit
 231# of a file in the working directory and add it to the index.
 232
 233test_chmod () {
 234        chmod "$@" &&
 235        git update-index --add "--chmod=$@"
 236}
 237
 238# Get the modebits from a file.
 239test_modebits () {
 240        ls -l "$1" | sed -e 's|^\(..........\).*|\1|'
 241}
 242
 243# Unset a configuration variable, but don't fail if it doesn't exist.
 244test_unconfig () {
 245        config_dir=
 246        if test "$1" = -C
 247        then
 248                shift
 249                config_dir=$1
 250                shift
 251        fi
 252        git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
 253        config_status=$?
 254        case "$config_status" in
 255        5) # ok, nothing to unset
 256                config_status=0
 257                ;;
 258        esac
 259        return $config_status
 260}
 261
 262# Set git config, automatically unsetting it after the test is over.
 263test_config () {
 264        config_dir=
 265        if test "$1" = -C
 266        then
 267                shift
 268                config_dir=$1
 269                shift
 270        fi
 271        test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
 272        git ${config_dir:+-C "$config_dir"} config "$@"
 273}
 274
 275test_config_global () {
 276        test_when_finished "test_unconfig --global '$1'" &&
 277        git config --global "$@"
 278}
 279
 280write_script () {
 281        {
 282                echo "#!${2-"$SHELL_PATH"}" &&
 283                cat
 284        } >"$1" &&
 285        chmod +x "$1"
 286}
 287
 288# Use test_set_prereq to tell that a particular prerequisite is available.
 289# The prerequisite can later be checked for in two ways:
 290#
 291# - Explicitly using test_have_prereq.
 292#
 293# - Implicitly by specifying the prerequisite tag in the calls to
 294#   test_expect_{success,failure,code}.
 295#
 296# The single parameter is the prerequisite tag (a simple word, in all
 297# capital letters by convention).
 298
 299test_unset_prereq () {
 300        ! test_have_prereq "$1" ||
 301        satisfied_prereq="${satisfied_prereq% $1 *} ${satisfied_prereq#* $1 }"
 302}
 303
 304test_set_prereq () {
 305        case "$1" in
 306        !*)
 307                test_unset_prereq "${1#!}"
 308                ;;
 309        *)
 310                satisfied_prereq="$satisfied_prereq$1 "
 311                ;;
 312        esac
 313}
 314satisfied_prereq=" "
 315lazily_testable_prereq= lazily_tested_prereq=
 316
 317# Usage: test_lazy_prereq PREREQ 'script'
 318test_lazy_prereq () {
 319        lazily_testable_prereq="$lazily_testable_prereq$1 "
 320        eval test_prereq_lazily_$1=\$2
 321}
 322
 323test_run_lazy_prereq_ () {
 324        script='
 325mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
 326(
 327        cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
 328)'
 329        say >&3 "checking prerequisite: $1"
 330        say >&3 "$script"
 331        test_eval_ "$script"
 332        eval_ret=$?
 333        rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
 334        if test "$eval_ret" = 0; then
 335                say >&3 "prerequisite $1 ok"
 336        else
 337                say >&3 "prerequisite $1 not satisfied"
 338        fi
 339        return $eval_ret
 340}
 341
 342test_have_prereq () {
 343        # prerequisites can be concatenated with ','
 344        save_IFS=$IFS
 345        IFS=,
 346        set -- $*
 347        IFS=$save_IFS
 348
 349        total_prereq=0
 350        ok_prereq=0
 351        missing_prereq=
 352
 353        for prerequisite
 354        do
 355                case "$prerequisite" in
 356                !*)
 357                        negative_prereq=t
 358                        prerequisite=${prerequisite#!}
 359                        ;;
 360                *)
 361                        negative_prereq=
 362                esac
 363
 364                case " $lazily_tested_prereq " in
 365                *" $prerequisite "*)
 366                        ;;
 367                *)
 368                        case " $lazily_testable_prereq " in
 369                        *" $prerequisite "*)
 370                                eval "script=\$test_prereq_lazily_$prerequisite" &&
 371                                if test_run_lazy_prereq_ "$prerequisite" "$script"
 372                                then
 373                                        test_set_prereq $prerequisite
 374                                fi
 375                                lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
 376                        esac
 377                        ;;
 378                esac
 379
 380                total_prereq=$(($total_prereq + 1))
 381                case "$satisfied_prereq" in
 382                *" $prerequisite "*)
 383                        satisfied_this_prereq=t
 384                        ;;
 385                *)
 386                        satisfied_this_prereq=
 387                esac
 388
 389                case "$satisfied_this_prereq,$negative_prereq" in
 390                t,|,t)
 391                        ok_prereq=$(($ok_prereq + 1))
 392                        ;;
 393                *)
 394                        # Keep a list of missing prerequisites; restore
 395                        # the negative marker if necessary.
 396                        prerequisite=${negative_prereq:+!}$prerequisite
 397                        if test -z "$missing_prereq"
 398                        then
 399                                missing_prereq=$prerequisite
 400                        else
 401                                missing_prereq="$prerequisite,$missing_prereq"
 402                        fi
 403                esac
 404        done
 405
 406        test $total_prereq = $ok_prereq
 407}
 408
 409test_declared_prereq () {
 410        case ",$test_prereq," in
 411        *,$1,*)
 412                return 0
 413                ;;
 414        esac
 415        return 1
 416}
 417
 418test_verify_prereq () {
 419        test -z "$test_prereq" ||
 420        expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
 421        error "bug in the test script: '$test_prereq' does not look like a prereq"
 422}
 423
 424test_expect_failure () {
 425        test_start_
 426        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 427        test "$#" = 2 ||
 428        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 429        test_verify_prereq
 430        export test_prereq
 431        if ! test_skip "$@"
 432        then
 433                say >&3 "checking known breakage: $2"
 434                if test_run_ "$2" expecting_failure
 435                then
 436                        test_known_broken_ok_ "$1"
 437                else
 438                        test_known_broken_failure_ "$1"
 439                fi
 440        fi
 441        test_finish_
 442}
 443
 444test_expect_success () {
 445        test_start_
 446        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 447        test "$#" = 2 ||
 448        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 449        test_verify_prereq
 450        export test_prereq
 451        if ! test_skip "$@"
 452        then
 453                say >&3 "expecting success: $2"
 454                if test_run_ "$2"
 455                then
 456                        test_ok_ "$1"
 457                else
 458                        test_failure_ "$@"
 459                fi
 460        fi
 461        test_finish_
 462}
 463
 464# test_external runs external test scripts that provide continuous
 465# test output about their progress, and succeeds/fails on
 466# zero/non-zero exit code.  It outputs the test output on stdout even
 467# in non-verbose mode, and announces the external script with "# run
 468# <n>: ..." before running it.  When providing relative paths, keep in
 469# mind that all scripts run in "trash directory".
 470# Usage: test_external description command arguments...
 471# Example: test_external 'Perl API' perl ../path/to/test.pl
 472test_external () {
 473        test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 474        test "$#" = 3 ||
 475        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 476        descr="$1"
 477        shift
 478        test_verify_prereq
 479        export test_prereq
 480        if ! test_skip "$descr" "$@"
 481        then
 482                # Announce the script to reduce confusion about the
 483                # test output that follows.
 484                say_color "" "# run $test_count: $descr ($*)"
 485                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 486                # to be able to use them in script
 487                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 488                # Run command; redirect its stderr to &4 as in
 489                # test_run_, but keep its stdout on our stdout even in
 490                # non-verbose mode.
 491                "$@" 2>&4
 492                if test "$?" = 0
 493                then
 494                        if test $test_external_has_tap -eq 0; then
 495                                test_ok_ "$descr"
 496                        else
 497                                say_color "" "# test_external test $descr was ok"
 498                                test_success=$(($test_success + 1))
 499                        fi
 500                else
 501                        if test $test_external_has_tap -eq 0; then
 502                                test_failure_ "$descr" "$@"
 503                        else
 504                                say_color error "# test_external test $descr failed: $@"
 505                                test_failure=$(($test_failure + 1))
 506                        fi
 507                fi
 508        fi
 509}
 510
 511# Like test_external, but in addition tests that the command generated
 512# no output on stderr.
 513test_external_without_stderr () {
 514        # The temporary file has no (and must have no) security
 515        # implications.
 516        tmp=${TMPDIR:-/tmp}
 517        stderr="$tmp/git-external-stderr.$$.tmp"
 518        test_external "$@" 4> "$stderr"
 519        test -f "$stderr" || error "Internal error: $stderr disappeared."
 520        descr="no stderr: $1"
 521        shift
 522        say >&3 "# expecting no stderr from previous command"
 523        if test ! -s "$stderr"
 524        then
 525                rm "$stderr"
 526
 527                if test $test_external_has_tap -eq 0; then
 528                        test_ok_ "$descr"
 529                else
 530                        say_color "" "# test_external_without_stderr test $descr was ok"
 531                        test_success=$(($test_success + 1))
 532                fi
 533        else
 534                if test "$verbose" = t
 535                then
 536                        output=$(echo; echo "# Stderr is:"; cat "$stderr")
 537                else
 538                        output=
 539                fi
 540                # rm first in case test_failure exits.
 541                rm "$stderr"
 542                if test $test_external_has_tap -eq 0; then
 543                        test_failure_ "$descr" "$@" "$output"
 544                else
 545                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 546                        test_failure=$(($test_failure + 1))
 547                fi
 548        fi
 549}
 550
 551# debugging-friendly alternatives to "test [-f|-d|-e]"
 552# The commands test the existence or non-existence of $1. $2 can be
 553# given to provide a more precise diagnosis.
 554test_path_is_file () {
 555        if ! test -f "$1"
 556        then
 557                echo "File $1 doesn't exist. $2"
 558                false
 559        fi
 560}
 561
 562test_path_is_dir () {
 563        if ! test -d "$1"
 564        then
 565                echo "Directory $1 doesn't exist. $2"
 566                false
 567        fi
 568}
 569
 570# Check if the directory exists and is empty as expected, barf otherwise.
 571test_dir_is_empty () {
 572        test_path_is_dir "$1" &&
 573        if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
 574        then
 575                echo "Directory '$1' is not empty, it contains:"
 576                ls -la "$1"
 577                return 1
 578        fi
 579}
 580
 581test_path_is_missing () {
 582        if test -e "$1"
 583        then
 584                echo "Path exists:"
 585                ls -ld "$1"
 586                if test $# -ge 1
 587                then
 588                        echo "$*"
 589                fi
 590                false
 591        fi
 592}
 593
 594# test_line_count checks that a file has the number of lines it
 595# ought to. For example:
 596#
 597#       test_expect_success 'produce exactly one line of output' '
 598#               do something >output &&
 599#               test_line_count = 1 output
 600#       '
 601#
 602# is like "test $(wc -l <output) = 1" except that it passes the
 603# output through when the number of lines is wrong.
 604
 605test_line_count () {
 606        if test $# != 3
 607        then
 608                error "bug in the test script: not 3 parameters to test_line_count"
 609        elif ! test $(wc -l <"$3") "$1" "$2"
 610        then
 611                echo "test_line_count: line count for $3 !$1 $2"
 612                cat "$3"
 613                return 1
 614        fi
 615}
 616
 617# Returns success if a comma separated string of keywords ($1) contains a
 618# given keyword ($2).
 619# Examples:
 620# `list_contains "foo,bar" bar` returns 0
 621# `list_contains "foo" bar` returns 1
 622
 623list_contains () {
 624        case ",$1," in
 625        *,$2,*)
 626                return 0
 627                ;;
 628        esac
 629        return 1
 630}
 631
 632# This is not among top-level (test_expect_success | test_expect_failure)
 633# but is a prefix that can be used in the test script, like:
 634#
 635#       test_expect_success 'complain and die' '
 636#           do something &&
 637#           do something else &&
 638#           test_must_fail git checkout ../outerspace
 639#       '
 640#
 641# Writing this as "! git checkout ../outerspace" is wrong, because
 642# the failure could be due to a segv.  We want a controlled failure.
 643#
 644# Accepts the following options:
 645#
 646#   ok=<signal-name>[,<...>]:
 647#     Don't treat an exit caused by the given signal as error.
 648#     Multiple signals can be specified as a comma separated list.
 649#     Currently recognized signal names are: sigpipe, success.
 650#     (Don't use 'success', use 'test_might_fail' instead.)
 651
 652test_must_fail () {
 653        case "$1" in
 654        ok=*)
 655                _test_ok=${1#ok=}
 656                shift
 657                ;;
 658        *)
 659                _test_ok=
 660                ;;
 661        esac
 662        "$@" 2>&7
 663        exit_code=$?
 664        if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
 665        then
 666                echo >&4 "test_must_fail: command succeeded: $*"
 667                return 1
 668        elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
 669        then
 670                return 0
 671        elif test $exit_code -gt 129 && test $exit_code -le 192
 672        then
 673                echo >&4 "test_must_fail: died by signal $(($exit_code - 128)): $*"
 674                return 1
 675        elif test $exit_code -eq 127
 676        then
 677                echo >&4 "test_must_fail: command not found: $*"
 678                return 1
 679        elif test $exit_code -eq 126
 680        then
 681                echo >&4 "test_must_fail: valgrind error: $*"
 682                return 1
 683        fi
 684        return 0
 685} 7>&2 2>&4
 686
 687# Similar to test_must_fail, but tolerates success, too.  This is
 688# meant to be used in contexts like:
 689#
 690#       test_expect_success 'some command works without configuration' '
 691#               test_might_fail git config --unset all.configuration &&
 692#               do something
 693#       '
 694#
 695# Writing "git config --unset all.configuration || :" would be wrong,
 696# because we want to notice if it fails due to segv.
 697#
 698# Accepts the same options as test_must_fail.
 699
 700test_might_fail () {
 701        test_must_fail ok=success "$@" 2>&7
 702} 7>&2 2>&4
 703
 704# Similar to test_must_fail and test_might_fail, but check that a
 705# given command exited with a given exit code. Meant to be used as:
 706#
 707#       test_expect_success 'Merge with d/f conflicts' '
 708#               test_expect_code 1 git merge "merge msg" B master
 709#       '
 710
 711test_expect_code () {
 712        want_code=$1
 713        shift
 714        "$@" 2>&7
 715        exit_code=$?
 716        if test $exit_code = $want_code
 717        then
 718                return 0
 719        fi
 720
 721        echo >&4 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
 722        return 1
 723} 7>&2 2>&4
 724
 725# test_cmp is a helper function to compare actual and expected output.
 726# You can use it like:
 727#
 728#       test_expect_success 'foo works' '
 729#               echo expected >expected &&
 730#               foo >actual &&
 731#               test_cmp expected actual
 732#       '
 733#
 734# This could be written as either "cmp" or "diff -u", but:
 735# - cmp's output is not nearly as easy to read as diff -u
 736# - not all diff versions understand "-u"
 737
 738test_cmp() {
 739        $GIT_TEST_CMP "$@"
 740}
 741
 742# test_cmp_bin - helper to compare binary files
 743
 744test_cmp_bin() {
 745        cmp "$@"
 746}
 747
 748# Use this instead of test_cmp to compare files that contain expected and
 749# actual output from git commands that can be translated.  When running
 750# under GETTEXT_POISON this pretends that the command produced expected
 751# results.
 752test_i18ncmp () {
 753        test -n "$GETTEXT_POISON" || test_cmp "$@"
 754}
 755
 756# Use this instead of "grep expected-string actual" to see if the
 757# output from a git command that can be translated either contains an
 758# expected string, or does not contain an unwanted one.  When running
 759# under GETTEXT_POISON this pretends that the command produced expected
 760# results.
 761test_i18ngrep () {
 762        eval "last_arg=\${$#}"
 763
 764        test -f "$last_arg" ||
 765        error "bug in the test script: test_i18ngrep requires a file" \
 766              "to read as the last parameter"
 767
 768        if test $# -lt 2 ||
 769           { test "x!" = "x$1" && test $# -lt 3 ; }
 770        then
 771                error "bug in the test script: too few parameters to test_i18ngrep"
 772        fi
 773
 774        if test -n "$GETTEXT_POISON"
 775        then
 776                # pretend success
 777                return 0
 778        fi
 779
 780        if test "x!" = "x$1"
 781        then
 782                shift
 783                ! grep "$@" && return 0
 784
 785                echo >&4 "error: '! grep $@' did find a match in:"
 786        else
 787                grep "$@" && return 0
 788
 789                echo >&4 "error: 'grep $@' didn't find a match in:"
 790        fi
 791
 792        if test -s "$last_arg"
 793        then
 794                cat >&4 "$last_arg"
 795        else
 796                echo >&4 "<File '$last_arg' is empty>"
 797        fi
 798
 799        return 1
 800}
 801
 802# Call any command "$@" but be more verbose about its
 803# failure. This is handy for commands like "test" which do
 804# not output anything when they fail.
 805verbose () {
 806        "$@" && return 0
 807        echo >&4 "command failed: $(git rev-parse --sq-quote "$@")"
 808        return 1
 809}
 810
 811# Check if the file expected to be empty is indeed empty, and barfs
 812# otherwise.
 813
 814test_must_be_empty () {
 815        test_path_is_file "$1" &&
 816        if test -s "$1"
 817        then
 818                echo "'$1' is not empty, it contains:"
 819                cat "$1"
 820                return 1
 821        fi
 822}
 823
 824# Tests that its two parameters refer to the same revision
 825test_cmp_rev () {
 826        git rev-parse --verify "$1" >expect.rev &&
 827        git rev-parse --verify "$2" >actual.rev &&
 828        test_cmp expect.rev actual.rev
 829}
 830
 831# Print a sequence of integers in increasing order, either with
 832# two arguments (start and end):
 833#
 834#     test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
 835#
 836# or with one argument (end), in which case it starts counting
 837# from 1.
 838
 839test_seq () {
 840        case $# in
 841        1)      set 1 "$@" ;;
 842        2)      ;;
 843        *)      error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
 844        esac
 845        test_seq_counter__=$1
 846        while test "$test_seq_counter__" -le "$2"
 847        do
 848                echo "$test_seq_counter__"
 849                test_seq_counter__=$(( $test_seq_counter__ + 1 ))
 850        done
 851}
 852
 853# This function can be used to schedule some commands to be run
 854# unconditionally at the end of the test to restore sanity:
 855#
 856#       test_expect_success 'test core.capslock' '
 857#               git config core.capslock true &&
 858#               test_when_finished "git config --unset core.capslock" &&
 859#               hello world
 860#       '
 861#
 862# That would be roughly equivalent to
 863#
 864#       test_expect_success 'test core.capslock' '
 865#               git config core.capslock true &&
 866#               hello world
 867#               git config --unset core.capslock
 868#       '
 869#
 870# except that the greeting and config --unset must both succeed for
 871# the test to pass.
 872#
 873# Note that under --immediate mode, no clean-up is done to help diagnose
 874# what went wrong.
 875
 876test_when_finished () {
 877        # We cannot detect when we are in a subshell in general, but by
 878        # doing so on Bash is better than nothing (the test will
 879        # silently pass on other shells).
 880        test "${BASH_SUBSHELL-0}" = 0 ||
 881        error "bug in test script: test_when_finished does nothing in a subshell"
 882        test_cleanup="{ $*
 883                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 884}
 885
 886# Most tests can use the created repository, but some may need to create more.
 887# Usage: test_create_repo <directory>
 888test_create_repo () {
 889        test "$#" = 1 ||
 890        error "bug in the test script: not 1 parameter to test-create-repo"
 891        repo="$1"
 892        mkdir -p "$repo"
 893        (
 894                cd "$repo" || error "Cannot setup test environment"
 895                "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
 896                error "cannot run git init -- have you built things yet?"
 897                mv .git/hooks .git/hooks-disabled
 898        ) || exit
 899}
 900
 901# This function helps on symlink challenged file systems when it is not
 902# important that the file system entry is a symbolic link.
 903# Use test_ln_s_add instead of "ln -s x y && git add y" to add a
 904# symbolic link entry y to the index.
 905
 906test_ln_s_add () {
 907        if test_have_prereq SYMLINKS
 908        then
 909                ln -s "$1" "$2" &&
 910                git update-index --add "$2"
 911        else
 912                printf '%s' "$1" >"$2" &&
 913                ln_s_obj=$(git hash-object -w "$2") &&
 914                git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
 915                # pick up stat info from the file
 916                git update-index "$2"
 917        fi
 918}
 919
 920# This function writes out its parameters, one per line
 921test_write_lines () {
 922        printf "%s\n" "$@"
 923}
 924
 925perl () {
 926        command "$PERL_PATH" "$@" 2>&7
 927} 7>&2 2>&4
 928
 929# Is the value one of the various ways to spell a boolean true/false?
 930test_normalize_bool () {
 931        git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
 932}
 933
 934# Given a variable $1, normalize the value of it to one of "true",
 935# "false", or "auto" and store the result to it.
 936#
 937#     test_tristate GIT_TEST_HTTPD
 938#
 939# A variable set to an empty string is set to 'false'.
 940# A variable set to 'false' or 'auto' keeps its value.
 941# Anything else is set to 'true'.
 942# An unset variable defaults to 'auto'.
 943#
 944# The last rule is to allow people to set the variable to an empty
 945# string and export it to decline testing the particular feature
 946# for versions both before and after this change.  We used to treat
 947# both unset and empty variable as a signal for "do not test" and
 948# took any non-empty string as "please test".
 949
 950test_tristate () {
 951        if eval "test x\"\${$1+isset}\" = xisset"
 952        then
 953                # explicitly set
 954                eval "
 955                        case \"\$$1\" in
 956                        '')     $1=false ;;
 957                        auto)   ;;
 958                        *)      $1=\$(test_normalize_bool \$$1 || echo true) ;;
 959                        esac
 960                "
 961        else
 962                eval "$1=auto"
 963        fi
 964}
 965
 966# Exit the test suite, either by skipping all remaining tests or by
 967# exiting with an error. If "$1" is "auto", we then we assume we were
 968# opportunistically trying to set up some tests and we skip. If it is
 969# "true", then we report a failure.
 970#
 971# The error/skip message should be given by $2.
 972#
 973test_skip_or_die () {
 974        case "$1" in
 975        auto)
 976                skip_all=$2
 977                test_done
 978                ;;
 979        true)
 980                error "$2"
 981                ;;
 982        *)
 983                error "BUG: test tristate is '$1' (real error: $2)"
 984        esac
 985}
 986
 987# The following mingw_* functions obey POSIX shell syntax, but are actually
 988# bash scripts, and are meant to be used only with bash on Windows.
 989
 990# A test_cmp function that treats LF and CRLF equal and avoids to fork
 991# diff when possible.
 992mingw_test_cmp () {
 993        # Read text into shell variables and compare them. If the results
 994        # are different, use regular diff to report the difference.
 995        local test_cmp_a= test_cmp_b=
 996
 997        # When text came from stdin (one argument is '-') we must feed it
 998        # to diff.
 999        local stdin_for_diff=
1000
1001        # Since it is difficult to detect the difference between an
1002        # empty input file and a failure to read the files, we go straight
1003        # to diff if one of the inputs is empty.
1004        if test -s "$1" && test -s "$2"
1005        then
1006                # regular case: both files non-empty
1007                mingw_read_file_strip_cr_ test_cmp_a <"$1"
1008                mingw_read_file_strip_cr_ test_cmp_b <"$2"
1009        elif test -s "$1" && test "$2" = -
1010        then
1011                # read 2nd file from stdin
1012                mingw_read_file_strip_cr_ test_cmp_a <"$1"
1013                mingw_read_file_strip_cr_ test_cmp_b
1014                stdin_for_diff='<<<"$test_cmp_b"'
1015        elif test "$1" = - && test -s "$2"
1016        then
1017                # read 1st file from stdin
1018                mingw_read_file_strip_cr_ test_cmp_a
1019                mingw_read_file_strip_cr_ test_cmp_b <"$2"
1020                stdin_for_diff='<<<"$test_cmp_a"'
1021        fi
1022        test -n "$test_cmp_a" &&
1023        test -n "$test_cmp_b" &&
1024        test "$test_cmp_a" = "$test_cmp_b" ||
1025        eval "diff -u \"\$@\" $stdin_for_diff"
1026}
1027
1028# $1 is the name of the shell variable to fill in
1029mingw_read_file_strip_cr_ () {
1030        # Read line-wise using LF as the line separator
1031        # and use IFS to strip CR.
1032        local line
1033        while :
1034        do
1035                if IFS=$'\r' read -r -d $'\n' line
1036                then
1037                        # good
1038                        line=$line$'\n'
1039                else
1040                        # we get here at EOF, but also if the last line
1041                        # was not terminated by LF; in the latter case,
1042                        # some text was read
1043                        if test -z "$line"
1044                        then
1045                                # EOF, really
1046                                break
1047                        fi
1048                fi
1049                eval "$1=\$$1\$line"
1050        done
1051}
1052
1053# Like "env FOO=BAR some-program", but run inside a subshell, which means
1054# it also works for shell functions (though those functions cannot impact
1055# the environment outside of the test_env invocation).
1056test_env () {
1057        (
1058                while test $# -gt 0
1059                do
1060                        case "$1" in
1061                        *=*)
1062                                eval "${1%%=*}=\${1#*=}"
1063                                eval "export ${1%%=*}"
1064                                shift
1065                                ;;
1066                        *)
1067                                "$@" 2>&7
1068                                exit
1069                                ;;
1070                        esac
1071                done
1072        )
1073} 7>&2 2>&4
1074
1075# Returns true if the numeric exit code in "$2" represents the expected signal
1076# in "$1". Signals should be given numerically.
1077test_match_signal () {
1078        if test "$2" = "$((128 + $1))"
1079        then
1080                # POSIX
1081                return 0
1082        elif test "$2" = "$((256 + $1))"
1083        then
1084                # ksh
1085                return 0
1086        fi
1087        return 1
1088}
1089
1090# Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1091test_copy_bytes () {
1092        perl -e '
1093                my $len = $ARGV[1];
1094                while ($len > 0) {
1095                        my $s;
1096                        my $nread = sysread(STDIN, $s, $len);
1097                        die "cannot read: $!" unless defined($nread);
1098                        last unless $nread;
1099                        print $s;
1100                        $len -= $nread;
1101                }
1102        ' - "$1"
1103}
1104
1105# run "$@" inside a non-git directory
1106nongit () {
1107        test -d non-repo ||
1108        mkdir non-repo ||
1109        return 1
1110
1111        (
1112                GIT_CEILING_DIRECTORIES=$(pwd) &&
1113                export GIT_CEILING_DIRECTORIES &&
1114                cd non-repo &&
1115                "$@" 2>&7
1116        )
1117} 7>&2 2>&4
1118
1119# convert stdin to pktline representation; note that empty input becomes an
1120# empty packet, not a flush packet (for that you can just print 0000 yourself).
1121packetize() {
1122        cat >packetize.tmp &&
1123        len=$(wc -c <packetize.tmp) &&
1124        printf '%04x%s' "$(($len + 4))" &&
1125        cat packetize.tmp &&
1126        rm -f packetize.tmp
1127}
1128
1129# Parse the input as a series of pktlines, writing the result to stdout.
1130# Sideband markers are removed automatically, and the output is routed to
1131# stderr if appropriate.
1132#
1133# NUL bytes are converted to "\\0" for ease of parsing with text tools.
1134depacketize () {
1135        perl -e '
1136                while (read(STDIN, $len, 4) == 4) {
1137                        if ($len eq "0000") {
1138                                print "FLUSH\n";
1139                        } else {
1140                                read(STDIN, $buf, hex($len) - 4);
1141                                $buf =~ s/\0/\\0/g;
1142                                if ($buf =~ s/^[\x2\x3]//) {
1143                                        print STDERR $buf;
1144                                } else {
1145                                        $buf =~ s/^\x1//;
1146                                        print $buf;
1147                                }
1148                        }
1149                }
1150        '
1151}